unit EDU05Dmo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    Timer1: TTimer;
    ProgressBar1: TProgressBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ProgressBar2: TProgressBar;
    Label5: TLabel;
    Label6: TLabel;
    ProgressBar3: TProgressBar;
    Label7: TLabel;
    Label10: TLabel;
    ProgressBar4: TProgressBar;
    Label11: TLabel;
    Label17: TLabel;
    ProgressBar5: TProgressBar;
    Label18: TLabel;
    TrackBar2: TTrackBar;
    Label14: TLabel;
    Label15: TLabel;
    TrackBar1: TTrackBar;
    Label12: TLabel;
    Label13: TLabel;
    GroupBox6: TGroupBox;
    Edit6: TEdit;
    Edit4: TEdit;
    Label19: TLabel;
    Button6: TButton;
    Button5: TButton;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Button2: TButton;
    Button4: TButton;
    CheckBox9: TCheckBox;
    Label8: TLabel;
    Button3: TButton;
    Label9: TLabel;
    Label16: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  IOMode: integer;
implementation

{$R *.DFM}
function OpenDevice: integer; stdcall; external 'EDU05D.dll';
procedure CloseDevice; stdcall; external 'EDU05D.dll';
function Connected: boolean; stdcall; external 'EDU05D.dll';
function ReadAnalogChannel(Channel: integer):integer; stdcall; external 'EDU05D.dll';
function ReadAllDigital: integer; stdcall; external 'EDU05D.dll';
procedure SetPWM(Channel: integer; Data: integer); stdcall; external 'EDU05D.dll';
procedure InOutMode(IOMode: integer);stdcall;  external 'EDU05D.dll';
procedure OutputAllDigital(Data: integer);stdcall;  external 'EDU05D.dll';
procedure ClearAllDigital; stdcall; external 'EDU05D.dll';
procedure SetAllDigital; stdcall; external 'EDU05D.dll';
procedure ClearDigitalChannel(Channel: integer); stdcall; external 'EDU05D.dll';
procedure SetDigitalChannel(Channel: integer); stdcall; external 'EDU05D.dll';

procedure LCDInit; stdcall; external 'EDU05D.dll';
procedure LCDClear; stdcall; external 'EDU05D.dll';
procedure LCDWriteString(Data: PChar; Position: integer); stdcall; external 'EDU05D.dll';
procedure StartupDemo(onoff: integer); stdcall; external 'EDU05D.dll';
function ReadBackStartupDemo: boolean; stdcall; external 'EDU05D.dll';

procedure TForm1.Button1Click(Sender: TObject);
begin
  Timer1.enabled:=false;
  case OpenDevice of
    0: begin
         CheckBox9.enabled:=false;
         label1.font.color:=clred;
         label1.caption:='EDU05 not found';
        end;
    1: begin
         label1.font.color:=clblack;
         label1.caption:='EDU05 connected';
         IOMode:=1;
         InOutMode(IOMode);
         RadioButton3.checked:=true;
         CheckBox9.enabled:=true;
         CheckBox9.checked:=ReadBackStartupDemo;
         Timer1.enabled:=true;
       end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  IOMode:=0;
  InOutMode(IOMode);
  SetAllDigital;
  RadioButton4.checked:=true;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  IOMode:=0;
  InOutMode(IOMode);
  ClearAllDigital;
  RadioButton4.checked:=true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseDevice;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i: integer;
ok:boolean;
Data: array [0..4] of integer;
begin
  timer1.enabled:=false;
  if Connected then
  begin
    label1.font.color:=clblack;
    label1.caption:='EDU05 connected';
    ok:=true;
  end
  else
  begin
    label1.font.color:=clred;
    label1.caption:='EDU05 disconnected';
    ok:=false;
  end;


  for i:=0 to 4 do
    Data[i]:=ReadAnalogChannel(i+1);
  ProgressBar1.position:=Data[0];
  ProgressBar2.position:=Data[1];
  ProgressBar3.position:=Data[2];
  ProgressBar4.position:=Data[3];
  ProgressBar5.position:=Data[4];
  Label3.caption:=inttostr(Data[0]);
  Label5.caption:=inttostr(Data[1]);
  Label7.caption:=inttostr(Data[2]);
  Label11.caption:=inttostr(Data[3]);
  Label18.caption:=inttostr(Data[4]);

  i:=ReadAllDigital;
  CheckBox1.checked:=(i and 1)>0;
  CheckBox2.checked:=(i and 2)>0;
  CheckBox3.checked:=(i and 4)>0;
  CheckBox4.checked:=(i and 8)>0;
  CheckBox5.checked:=(i and 16)>0;
  CheckBox6.checked:=(i and 32)>0;
  CheckBox7.checked:=(i and 64)>0;
  CheckBox8.checked:=(i and 128)>0;
  if ok then
    timer1.enabled:=true;
end;

procedure TForm1.RadioButton4Click(Sender: TObject);
begin
  IOMode:=0;
  InOutMode(IOMode);
  CheckBox1.Enabled:=true;
  CheckBox2.Enabled:=true;
  CheckBox3.Enabled:=true;
  CheckBox4.Enabled:=true;
  CheckBox5.Enabled:=true;
  CheckBox6.Enabled:=true;
  CheckBox7.Enabled:=true;
  CheckBox8.Enabled:=true;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
  IOMode:=1;
  InOutMode(IOMode);
  CheckBox1.Enabled:=false;
  CheckBox2.Enabled:=false;
  CheckBox3.Enabled:=false;
  CheckBox4.Enabled:=false;
  CheckBox5.Enabled:=false;
  CheckBox6.Enabled:=false;
  CheckBox7.Enabled:=false;
  CheckBox8.Enabled:=false;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if IOMode=0 then
    if CheckBox1.checked then
      SetDigitalChannel(1)
    else
      ClearDigitalChannel(1);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if IOMode=0 then
    if CheckBox2.checked then
      SetDigitalChannel(2)
    else
      ClearDigitalChannel(2);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if IOMode=0 then
    if CheckBox3.checked then
      SetDigitalChannel(3)
    else
      ClearDigitalChannel(3);
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  if IOMode=0 then
    if CheckBox4.checked then
      SetDigitalChannel(4)
    else
      ClearDigitalChannel(4);
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  if IOMode=0 then
    if CheckBox5.checked then
      SetDigitalChannel(5)
    else
      ClearDigitalChannel(5);
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  if IOMode=0 then
    if CheckBox6.checked then
      SetDigitalChannel(6)
    else
      ClearDigitalChannel(6);
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  if IOMode=0 then
    if CheckBox7.checked then
      SetDigitalChannel(7)
    else
      ClearDigitalChannel(7);
end;

procedure TForm1.CheckBox8Click(Sender: TObject);
begin
  if IOMode=0 then
    if CheckBox8.checked then
      SetDigitalChannel(8)
    else
      ClearDigitalChannel(8);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  SetPWM(1,255-TrackBar1.position);
  Label13.caption:=inttostr(255-TrackBar1.position);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  SetPWM(2,255-TrackBar2.position);
  Label15.caption:=inttostr(255-TrackBar2.position);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  InOutMode(0);
  LCDClear;
  InOutMode(IOMode);
end;

procedure TForm1.Button6Click(Sender: TObject);
var s: string;
i: integer;
begin
  InOutMode(0);
  s:=edit6.text;
  LCDClear;
  LCDWriteString(PChar(s), StrToInt(Edit4.Text));
  InOutMode(IOMode);
end;

procedure TForm1.CheckBox9Click(Sender: TObject);
begin
  if CheckBox9.checked then
    StartupDemo(0)
  else
    StartupDemo(255);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  CloseDevice;
end;

end.
